DialogChat_Options={}
DialogChat_Aliases={}
DialogChat_Blacklist={}
local DCRPlayerIndex=""
DCR_ColorChanging=""
local DCR_TempProfile={}
local DCR_Disabled=false
local OldChatFrame_Handler = ChatFrame_MessageEventHandler;
UnitPopupButtons["WHO"]	= { text = "Who?", dist = 0 };
UnitPopupButtons["DCR_INSPECT"]	= { text = "Inspect Target", dist = 0 };
UnitPopupButtons["DCR_TRADE"]	= { text = "Open Trade", dist = 0 };
UnitPopupButtons["ADD_FRIEND"]	= { text = "Add Friend", dist = 0 };
UnitPopupButtons["ADD_IGNORE"]	= { text = "Add Ignore", dist = 0 };

UnitPopupMenus["DCR_PLAYER"] = { "WHO", "INVITE", "FOLLOW", "RAID_TARGET_ICON", "CANCEL" };
UnitPopupMenus["DCR_SELF"] = { "PVP_FLAG", "LOOT_METHOD", "LOOT_THRESHOLD", "OPT_OUT_LOOT_TITLE", "LOOT_PROMOTE", "DUNGEON_DIFFICULTY", "RESET_INSTANCES", "RAID_TARGET_ICON", "LEAVE", "CANCEL" };
UnitPopupMenus["DCR_TARGET"] = { "WHO", "DCR_INSPECT", "INVITE", "DCR_TRADE", "FOLLOW", "RAID_TARGET_ICON", "CANCEL" };
UnitPopupMenus["DCR_PARTY"] = { "WHO", "MUTE", "UNMUTE", "PARTY_SILENCE", "PARTY_UNSILENCE", "RAID_SILENCE", "RAID_UNSILENCE", "BATTLEGROUND_SILENCE", "BATTLEGROUND_UNSILENCE", "PROMOTE", "LOOT_PROMOTE", "UNINVITE", "FOLLOW", "RAID_TARGET_ICON", "PVP_REPORT_AFK", "CANCEL" };
UnitPopupMenus["DCR_RAID"] = { "WHO", "MUTE", "UNMUTE", "RAID_SILENCE", "RAID_UNSILENCE", "BATTLEGROUND_SILENCE", "BATTLEGROUND_UNSILENCE", "FOLLOW", "RAID_TARGET_ICON", "RAID_LEADER", "RAID_PROMOTE", "RAID_DEMOTE", "LOOT_PROMOTE", "RAID_REMOVE", "PVP_REPORT_AFK", "CANCEL" };
UnitPopupMenus["DCR_FOCUS"] = { "WHO", "INVITE", "FOLLOW", "RAID_TARGET_ICON", "CANCEL" };
UnitPopupMenus["DCR_SUB"] = { "ADD_FRIEND", "ADD_IGNORE", "GUILD_PROMOTE", "TEAM_PROMOTE", "TEAM_KICK", "CANCEL" };
local DCR_DropDownMenu_FullName;


------------------------------------------------------------
-- Event Handler
------------------------------------------------------------
function DCRC_OnLoad()
	--Basic OnLoad function(s)... Setting up the slash handler
	SlashCmdList["DIALOGCHATCC"] = function(msg) DCRC_SlashHandler(msg) end;
	SLASH_DIALOGCHATCC1 = "/dialogchat";
	DCRC_UnitPopup_OnClick_sub = UnitPopup_OnClick;
	UnitPopup_OnClick = DCRC_UnitPopup_OnClick;
end
function DCRC_Initialization()
	DCRPlayerIndex=UnitName("player").."."..GetRealmName()
	OldChatFrame_Handler = ChatFrame_MessageEventHandler;
	ChatFrame_MessageEventHandler = DCRC_ChatFrame_OnEvent;
	if(DialogChat_Options==nil)then DialogChat_Options={} end
	if(DialogChat_Options[DCRPlayerIndex]==nil)then DialogChat_Options[DCRPlayerIndex]={} DCRC_SetupDefaultProfile(DCRPlayerIndex) end
	if(DialogChat_Aliases==nil)then DialogChat_Aliases={} end
	if(DialogChat_Aliases[GetRealmName()]==nil)then DialogChat_Aliases[GetRealmName()]={} end
	DCRC_LoadSavedVariables()
end
function DCRC_ChatFrame_OnEvent(self, event, ...)
	if 
		event=="CHAT_MSG_WHISPER" or 
		event=="CHAT_MSG_WHISPER_INFORM" or 
		event=="CHAT_MSG_AFK" or 
		event=="CHAT_MSG_DND" 
	then
		if(DCRC_IsValidWhisper(arg1, arg2)==0)then
		else
			return
		end
	end
	OldChatFrame_Handler(self, event, ...)
end
function DCRC_OnEvent(event)
	if (event == "ADDON_LOADED") and (arg1=="DialogChat") then
		DCRC_Initialization()
	elseif(event=="CHAT_MSG_WHISPER")then
		if(DCR_Disabled==true)then return end
		valid=DCRC_IsValidWhisper(arg1, arg2)
		if(valid==1)then
			DCR_IncomingMessage(arg2, arg1)
			if(DCRC_GetOption("UseDock")==1) then
				DCRD_IncomingMessage(arg2, arg1)
			end
			DCRL_IncomingMessage(arg2, arg1)
			ChatEdit_SetLastTellTarget(arg2, ChatFrame1.editBox)


if InCombatLockdown() then
	if (DCRC_GetOption("UseDock")==1)then
		DCRD_EnterCombat()
	else
		DCR_EnterCombat()
	end
end


		end
	elseif(event=="CHAT_MSG_WHISPER_INFORM")then
		if(DCR_Disabled==true)then return end
		valid=DCRC_IsValidWhisper(arg1, arg2, 0)
		if(valid==1)then
			DCR_OutgoingMessage(arg2, arg1)
			if(DCRC_GetOption("UseDock")==1) then
				DCRD_OutgoingMessage(arg2, arg1)
			end
			DCRL_OutgoingMessage(arg2, arg1)
			ChatEdit_SetLastToldTarget(arg2, ChatFrame1.editBox)
		end
	elseif(event=="CHAT_MSG_AFK")then
		if(DCR_Disabled==true)then return end
		getglobal("Window"..DCR_UsedFrames[arg2].."_Main_Chat"):AddMessage(arg2.." is currently AFK: "..arg1, DCRC_ParseColor(DCRC_GetOption("AFKColor")))
		DEFAULT_CHAT_FRAME:AddMessage("AFK message noted")
	elseif(event=="WHO_LIST_UPDATE")then
		DCR_WhoActivated()
	elseif(event=="PLAYER_REGEN_DISABLED")then
		if(DCR_Disabled==true)then return end
		if (DCRC_GetOption("UseDock")==1)then
			DCRD_EnterCombat()
		else
			DCR_EnterCombat()
		end
	elseif(event=="PLAYER_REGEN_ENABLED")then
		if(DCR_Disabled==true)then return end
		if (DCRC_GetOption("UseDock")==1) then
			DCRD_ExitCombat()
		else
			DCR_ExitCombat()
		end
	end
end
function DCRC_UnitPopup_OnClick(self)
	local fullname = DCR_DropDownMenu_FullName;

	if ( button == "WHO" ) then
		SetWhoToUI(0);
		SendWho(fullname);
		DCR_UpdateWhoField(fullname);
		PlaySound("UChatScrollButton");
	elseif ( button == "DCR_INSPECT" ) then
		InspectUnit("target");
		PlaySound("UChatScrollButton");
	elseif ( button == "DCR_TRADE" ) then
		InitiateTrade("target");
		PlaySound("UChatScrollButton");
	elseif ( button == "ADD_FRIEND" ) then
		AddFriend(fullname);
		PlaySound("UChatScrollButton");
	elseif ( button == "ADD_IGNORE" ) then
		AddIgnore(fullname);
		PlaySound("UChatScrollButton");
	else
		DCRC_UnitPopup_OnClick_sub(self)
	end
end
------------------------------------------------------------
-- Slash Command
------------------------------------------------------------
function DCRC_SlashHandler(msg)
	--Basic slash handler.
	if (msg=="") then
		if(DCRC_OptionWindow:IsVisible())then
			DCRC_OptionWindow:Hide()
		else
			DCRC_OptionWindow:Show()
		end
	elseif(msg=="enable")then
		DCR_Enable()
		if(DCR_Disabled==true)then
			OldChatFrame_OnEvent=ChatFrame_MessageEventHandler
			ChatFrame_MessageEventHandler=DCRC_ChatFrame_OnEvent
			DCR_Disabled=false
			DEFAULT_CHAT_FRAME:AddMessage("DCR:DialogChatWindow:ON")
		end
		
	elseif(msg=="disable")then
		DCR_Disable()
		if(DCR_Disabled==false)then
			ChatFrame_MessageEventHandler=OldChatFrame_OnEvent
			DCR_Disabled=true
			DEFAULT_CHAT_FRAME:AddMessage("DCR:DialogChatWindow:OFF")
		end
	elseif(msg=="log")then
		DCRL_ShowHistory()
	elseif(msg=="reset")then
		DCR_ResetWidgetPositions()
	else
		DCR_AllocateFrame(msg)
	end
end
------------------------------------------------------------
-- Save/Load Option
------------------------------------------------------------
function DCRC_SetOption(Setting, Value)
	if(Value==nil)then Value=0 end
	DialogChat_Options[DCRPlayerIndex][Setting]=Value
end
function DCRC_GetOption(Setting)
	return DialogChat_Options[DCRPlayerIndex][Setting]
end
function DCRC_SetupDefaultProfile(PlayerIndex)
	--Set ALL needed variables to their default state.
	DialogChat_Options[PlayerIndex]={}
	DialogChat_Options[PlayerIndex]["MinimizeUp"]=1
	DialogChat_Options[PlayerIndex]["TimeStamp"]=1
	DialogChat_Options[PlayerIndex]["LoadMinimized"]=0
	DialogChat_Options[PlayerIndex]["CombatMinimize"]=1
	DialogChat_Options[PlayerIndex]["CombatHide"]=0
	DialogChat_Options[PlayerIndex]["InboundColor"]="1,0.67,0.95"
	DialogChat_Options[PlayerIndex]["OutboundColor"]="0,1,1"
	DialogChat_Options[PlayerIndex]["HighlightColor"]="0,0,0"
	DialogChat_Options[PlayerIndex]["NameColor"]="1,1,1"
	DialogChat_Options[PlayerIndex]["DetailColor"]="0,1,0"
	DialogChat_Options[PlayerIndex]["HistoryColor"]="0,0,1"
	DialogChat_Options[PlayerIndex]["AFKColor"]="1,0,0"
	DialogChat_Options[PlayerIndex]["PulseColor"]="0,0,0"
	DialogChat_Options[PlayerIndex]["Transparency"]=1
	DialogChat_Options[PlayerIndex]["GuildAndFriendsOnly"]=0
	DialogChat_Options[PlayerIndex]["MAXwidgets"]=14
	DialogChat_Options[PlayerIndex]["AlertSound"]="OFF"
	DialogChat_Options[PlayerIndex]["DisplayNumUnread"]=1
	DialogChat_Options[PlayerIndex]["FontSize"]=12
	DialogChat_Options[PlayerIndex]["COREdimensionX"]=350	
	DialogChat_Options[PlayerIndex]["COREdimensionY"]=140	
	DialogChat_Options[PlayerIndex]["EditOnClick"]=1
	DialogChat_Options[PlayerIndex]["WidgetScale"]=1
	DialogChat_Options[PlayerIndex]["TimeoutSeconds"]=180
	DialogChat_Options[PlayerIndex]["LevelThreshold"]=1
	DialogChat_Options[PlayerIndex]["SelectiveWidgets"]=0
	DialogChat_Options[PlayerIndex]["IgnoreWhos"]=1
	DialogChat_Options[PlayerIndex]["RecordHistory"]=1
	DialogChat_Options[PlayerIndex]["EmptyOnLoad"]=0
	DialogChat_Options[PlayerIndex]["HistoryLinesInWidget"]=20
	DialogChat_Options[PlayerIndex]["ScrollButtons"]=0
	DialogChat_Options[PlayerIndex]["UseDock"]=1
	DialogChat_Options[PlayerIndex]["MessageHeadder_Inc"]="NAME"
	DialogChat_Options[PlayerIndex]["MessageHeadder_Out"]="NAME"
	DialogChat_Options[PlayerIndex]["Window1_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window2_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window3_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window4_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window5_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window6_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window7_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window8_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window9_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window10_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window11_minimized"]=0
	DialogChat_Options[PlayerIndex]["Window12_minimized"]=0

	DialogChat_Options[PlayerIndex]["DockPosition_Right"]=0
	DialogChat_Options[PlayerIndex]["DockPosition_Inside"]=0
	DialogChat_Options[PlayerIndex]["DockAutoHide"]=0
	DialogChat_Options[PlayerIndex]["DockWidth"]=150

	DCRC_AddBlacklist("GA\t")
	DCRC_AddBlacklist("[CTA]")
	DCRC_AddBlacklist("LVPN")
	DCRC_AddBlacklist("LVBM")
	DCRC_AddBlacklist("YOU ARE THE BOMB!")
	DCRC_AddBlacklist("YOU HAVE BURNING ADRENALINE!")
	DCRC_AddBlacklist("You are Little Red")
	DCRC_AddBlacklist("You are being watched!")
end
function DCRC_LoadSavedVariables()
	ProfileBackup={}
	--Copy ALL elements of the current saved variables into the BackupProfile
	for index, entry in pairs(DialogChat_Options[DCRPlayerIndex])do
		ProfileBackup[index]=DialogChat_Options[DCRPlayerIndex][index]
	end
	DialogChat_Options[DCRPlayerIndex]=nil
	DCRC_SetupDefaultProfile(DCRPlayerIndex)
	for index, entry in pairs(DialogChat_Options[DCRPlayerIndex])do
		if(ProfileBackup[index]~=nil)then
			DialogChat_Options[DCRPlayerIndex][index]=ProfileBackup[index]
		end
	end
end
------------------------------------------------------------
-- DropDown Menu
------------------------------------------------------------
function DCRC_DropDownAudioAlert_OnShow()
	UIDropDownMenu_Initialize(this, DCRC_DropDownAudioAlert);
	UIDropDownMenu_SetSelectedID(this, DCRC_GetIDAudioAlert(DCRC_GetOption("AlertSound")));
	UIDropDownMenu_SetWidth(this,80);
end
function DCRC_DropDownHeadderInc_OnShow()
	UIDropDownMenu_Initialize(this, DCRC_DropDownHeadderInc);
	UIDropDownMenu_SetSelectedID(this, DCRC_GetIDHeadderInc(DCRC_GetOption("MessageHeadder_Inc")));
	UIDropDownMenu_SetWidth(this,80);
end
function DCRC_DropDownHeadderOut_OnShow()
	UIDropDownMenu_Initialize(this, DCRC_DropDownHeadderOut);
	UIDropDownMenu_SetSelectedID(this, DCRC_GetIDHeadderOut(DCRC_GetOption("MessageHeadder_Out")));
	UIDropDownMenu_SetWidth(this,80);
end
function DCRC_DropDownAudioAlert()
	local info;
	info = {
			text = "OFF";
			func = DCRC_DropDownAudioAlertOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "PING";
			func = DCRC_DropDownAudioAlertOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "DING";
			func = DCRC_DropDownAudioAlertOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "DINGDONG";
			func = DCRC_DropDownAudioAlertOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "NOTIFY";
			func = DCRC_DropDownAudioAlertOnClick;
	};
	UIDropDownMenu_AddButton(info);
end
function DCRC_DropDownHeadderInc()
	local info;
	info = {
			text = "NAME";
			func = DCRC_DropDownHeadderIncOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = ":";
			func = DCRC_DropDownHeadderIncOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = ">";
			func = DCRC_DropDownHeadderIncOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "[INC]";
			func = DCRC_DropDownHeadderIncOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "[IN]";
			func = DCRC_DropDownHeadderIncOnClick;
	};
	UIDropDownMenu_AddButton(info);
end
function DCRC_DropDownHeadderOut()
	local info;
	info = {
			text = "NAME";
			func = DCRC_DropDownHeadderOutOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = ":";
			func = DCRC_DropDownHeadderOutOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "<";
			func = DCRC_DropDownHeadderOutOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "[SEND]";
			func = DCRC_DropDownHeadderOutOnClick;
	};
	UIDropDownMenu_AddButton(info);
	info = {
			text = "[OUT]";
			func = DCRC_DropDownHeadderOutOnClick;
	};
	UIDropDownMenu_AddButton(info);
end
function DCRC_GetIDAudioAlert(sound)
	if sound == "OFF" then
		return 1;
	elseif sound == "PING" then
		return 2;
	elseif sound == "DING" then
		return 3;
	elseif sound == "DINGDONG" then
		return 4;
	elseif sound == "NOTIFY" then
		return 5;
	end
end
function DCRC_GetIDHeadderInc(inc)
	if inc == "NAME" then
		return 1;
	elseif inc == ":" then
		return 2;
	elseif inc == ">" then
		return 3;
	elseif inc == "[INC]" then
		return 4;
	elseif inc == "[IN]" then
		return 5;
	end
end
function DCRC_GetIDHeadderOut(out)
	if out == "NAME" then
		return 1;
	elseif out == ":" then
		return 2;
	elseif out == "<" then
		return 3;
	elseif out == "[SEND]" then
		return 4;
	elseif out == "[OUT]" then
		return 5;
	end
end
function DCRC_DropDownAudioAlertOnClick()
	local i = this:GetID();
	local j = DCRC_GetIDAudioAlert(DCRC_GetOption("AlertSound"));
	UIDropDownMenu_SetSelectedID(DCRC_OptionWindow_Behavior_Panel_AudibleAlert_Toggle, i);
	DCRC_SetOption("AlertSound", DCRC_OptionWindow_Behavior_Panel_AudibleAlert_ToggleText:GetText())
	if(DCRC_GetOption("AlertSound")~="OFF")then
		PlaySoundFile("Interface\\AddOns\\DialogChat\\Sounds\\"..DCRC_GetOption("AlertSound")..".wav");
	end
end
function DCRC_DropDownHeadderIncOnClick()
	local i = this:GetID();
	local j = DCRC_GetIDHeadderInc(DCRC_GetOption("MessageHeadder_Inc"));
	UIDropDownMenu_SetSelectedID(DCRC_OptionWindow_Behavior_Panel_DropDownHeadderInc, i);
	DCRC_SetOption("MessageHeadder_Inc", DCRC_OptionWindow_Behavior_Panel_DropDownHeadderIncText:GetText())
end
function DCRC_DropDownHeadderOutOnClick()
	local i = this:GetID();
	local j = DCRC_GetIDHeadderOut(DCRC_GetOption("MessageHeadder_Out"));
	UIDropDownMenu_SetSelectedID(DCRC_OptionWindow_Behavior_Panel_DropDownHeadderOut, i);
	DCRC_SetOption("MessageHeadder_Out", DCRC_OptionWindow_Behavior_Panel_DropDownHeadderOutText:GetText())
end
function DCRC_DropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, DCRC_DropDown_Initialize, "MENU");
end
function DCRC_DropDown_Initialize(self)
	local menu, name, unit;
	local id = nil;
	menu = "DCR_PLAYER";
	name = self:GetParent():GetParent().Name;
	if GetNumRaidMembers() > 1 then
		for i=1, GetNumRaidMembers() do
			raid_name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
			if(name==raid_name)then
				unit = "raid"..i;
				menu = "DCR_RAID";
			end
		end
	end
	if name == UnitName("focus") then
		unit = "focus";
		menu = "DCR_FOCUS";
	end
	for i=1,4 do
		if name == UnitName("party"..i) then
			unit = "party"..i;
			menu = "DCR_PARTY";
		end
	end
	if name == UnitName("target") then
		unit = "target";
		menu = "DCR_TARGET";
	end
	if name == UnitName("pet") then
		unit = "pet";
		menu = "PET";
	end
	if name == UnitName("player") then
		unit = "player";
		menu = "DCR_SELF";
	end
	if (IsShiftKeyDown()) then
		menu = "DCR_SUB";
	end
	if ( menu ) then
		UnitPopup_ShowMenu(self, menu, unit, name, id);
	end
	DCR_DropDownMenu_FullName = name;

end
function DCRC_DropDownMenu(frame)
	ToggleDropDownMenu(1, nil, getglobal(frame.."_MoveIt_DropDown"), frame .."_MoveIt", 0, 0);
end
------------------------------------------------------------
-- Utility
------------------------------------------------------------
function DCRC_ColorPicked()
	if(DCR_ColorChanging=="")then return end
	R,G,B = ColorPickerFrame:GetColorRGB();
	DCRC_SetOption(DCR_ColorChanging, R..","..G..","..B)
	getglobal("DCRC_OptionWindow_Appearance_Panel_"..DCR_ColorChanging.."_Chooser_Text"):SetTextColor(R,G,B)
end
function DCRC_ParseColor(ColorString)
	r=0
	g=0
	b=0
	locComma=string.find(ColorString, ",")
	r=string.sub(ColorString,0,locComma-1)
	ColorString=string.sub(ColorString, locComma+1)
	locComma=string.find(ColorString, ",")
	g=string.sub(ColorString,0,locComma-1)
	ColorString=string.sub(ColorString, locComma+1)
	b=ColorString
	return r,g,b
end
function DCRC_GetPlayerIndex()
	return DCRPlayerIndex
end
function DCRC_IsValidWhisper(Text, Name)
	if(DCRC_IsGuildieOrFriend(Name)==false) and (DCRC_GetOption("SelectiveWidgets")==1) then return 0 end
	
	if(Text==nil)then return 1 end
	if(Name==nil)then return 1 end






	for i=1, table.getn(DialogChat_Blacklist) do
		smple=string.sub(Text, 1, string.len(DialogChat_Blacklist[i]))
		if (smple==DialogChat_Blacklist[i]) then
			return 0
		end
	end
	return 1;
end
function DCRC_IsGuildieOrFriend(Name)
	--Checks Aliases
	if(DialogChat_Aliases[Name]~=nil)then return true end
	
	--Checks Friends
	for i=1, GetNumFriends() do
		name, level, class, area, connected, status = GetFriendInfo(i)
		if(name==Name) then return true end
	end
	
	--Checks Guildies
	for i=1, GetNumGuildMembers() do
		name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
		if(name==Name) then return true end
	end

	return false
end
------------------------------------------------------------
-- Window Button
------------------------------------------------------------
function DCRC_CloseButtonClicked(Name)
	if (DCRC_GetOption("UseDock")==0) then
		DCR_CloseButtonClicked(Name);
	else
		DCRD_CloseButtonClicked();
	end
end
function DCRC_ToggleMinimizeWindow(Name)
	if (DCRC_GetOption("UseDock")==0) then
		DCR_ToggleMinimizeWindow(Name);
	else
		DCRD_ToggleMinimizeWindow();
	end
end
function DCRC_OnMouseDown()
	if arg1 == "RightButton" then
		DCRC_DropDown_OnLoad(getglobal(this:GetName().."_DropDown"));
		DCRC_DropDownMenu(this:GetParent():GetName());
	else
		if (DCRC_GetOption("UseDock")==0) then
			this:GetParent():StartMoving();
		else
			DCRD_OnMouseDown();
		end
	end
end
function DCRC_OnMouseUp()
	if (DCRC_GetOption("UseDock")==0) then
		this:GetParent():StopMovingOrSizing();
	else
		DCRD_OnMouseUp();
	end
end
function DCRC_Mouseover_OnEnter()
	if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Inside")==0) then
		DCRD_Mouseover_OnEnter()
	end
end
function DCRC_Mouseover_OnLeave()
	if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Inside")==0) then
		DCRD_Mouseover_OnLeave()
	end
end
function DCRC_TimeoutFrame(frame,arg1)
	if (DCRC_GetOption("UseDock")==1) then
		if getglobal("DCR_DockList"):IsShown() and getglobal("DCR_DockList").Minimized ~=1 and getglobal("DCR_DockList").CombatHidden ~=1 then
			frame.SecondsSinceLastEvent=frame.SecondsSinceLastEvent+arg1
		end
	elseif(frame.Minimized==0)then
		frame.SecondsSinceLastEvent=frame.SecondsSinceLastEvent+arg1
	end
	if(frame.SecondsSinceLastEvent>DCRC_GetOption("TimeoutSeconds"))then
		if (DCRC_GetOption("UseDock")==1) then
			DCRD_TimeoutFrame(frame.Name)
		else
			DCR_TimeoutFrame(frame.Name)
		end
	end
end
function DCRC_AddIgnore(Name)
	AddIgnore(Name);
	if(DCRC_GetOption("UseDock")==1) then
		DCRD_CloseButtonClicked();
	else
		DCR_DeAllocateFrameByName(Name);
	end
end
------------------------------------------------------------
-- Black List/Alias List
------------------------------------------------------------
function DCRC_UpdateBlacklist(topIndex)
	table.sort(DialogChat_Blacklist)
	--Updates the Blacklist on the options frame starting at row topIndex
	for ind=1, 12 do
		--Clears all elements of the blacklist.
		getglobal("DCRC_OptionWindow_Blacklist_Panel_Entry"..ind.."_Text"):SetText("")
		getglobal("DCRC_OptionWindow_Blacklist_Panel_Entry"..ind):SetText("")
		getglobal("DCRC_OptionWindow_Blacklist_Panel_Entry"..ind):Hide()
	end
	
	--each row contains three elements, 'start' finds the proper element within the list for that row.
	start=topIndex
	j=1
	for i=start, start+11 do
		--Displays the desired list elements from start to start+35
		if(i>table.getn(DialogChat_Blacklist))then break end
		--Concatenates long blacklist elements to the first 12 characters followed by an elipse (...)
		getglobal("DCRC_OptionWindow_Blacklist_Panel_Entry"..j.."_Text"):SetText(DialogChat_Blacklist[i])
		getglobal("DCRC_OptionWindow_Blacklist_Panel_Entry"..j):Show()
		j=j+1
	end
	
	i=table.getn(DialogChat_Blacklist)
	if(i<=12)then
		--the entire list can be displayed on one unscrolling list.
		DCRC_OptionWindow_Blacklist_Panel_Scroller:SetMinMaxValues(1,1)
	else
		--Finds the new maximum value of the scroll list.  
		DCRC_OptionWindow_Blacklist_Panel_Scroller:SetMinMaxValues(1,table.getn(DialogChat_Blacklist)-11)
	end
end
function DCRC_RemoveBlacklist(Text)
	--Removes the requested item from the Blacklist.
	for i=1, table.getn(DialogChat_Blacklist) do
		if(DialogChat_Blacklist[i]==Text)then
			table.remove(DialogChat_Blacklist, i)
			i=i-1
		end
	end
end
function DCRC_AddBlacklist(Text)
	--Checks if an entry is in the blacklist.  if it is not, adds it.
	for i=1, table.getn(DialogChat_Blacklist) do
		if(DialogChat_Blacklist[i]==Text)then
			return
		end
	end
	table.insert(DialogChat_Blacklist, Text)
end
--
function DCRC_UpdateAliasList(topIndex)
	table.sort(DialogChat_Aliases[GetRealmName()])
	--This function updates the alias list on the options framestarting at topIndex
	for ind=1, 12 do
		--Clears all 12 list elements.
		getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..ind.."_Alias"):SetText("")
		getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..ind):SetText("")
		getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..ind):Hide()
		getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..ind.."_DeleteButton"):Hide()
	end
	i=1
	j=1
	for index, entry in pairs(DialogChat_Aliases[GetRealmName()]) do
		if(i>=topIndex) and (i<topIndex+12)then
			--Displays the topIndex's element through to the topIndex+12'th element in the list
			getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..j.."_Character"):SetText(index)
			getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..j.."_Alias"):SetText(DialogChat_Aliases[GetRealmName()][index])
			getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..j):Show()
			getglobal("DCRC_OptionWindow_Aliases_Panel_Entry"..j.."_DeleteButton"):Show()
			j=j+1
		end
		i=i+1
	end
	
	if(i<=12)then
		--the entire list will be displayed on a single, un-scrolling list.
		DCRC_OptionWindow_Aliases_Panel_Scroller:SetMinMaxValues(1,1)
	else		
		--The list will require scrolling.
		DCRC_OptionWindow_Aliases_Panel_Scroller:SetMinMaxValues(1,i-12)
	end
end
function DCRC_RemoveAliasFromList(Character) 
	--Guess what this does.
	DialogChat_Aliases[GetRealmName()][Character]=nil
end
function DCRC_SetAlias(Character, Alias)
	DialogChat_Aliases[GetRealmName()][Character]=Alias
end
------------------------------------------------------------
-- Profile
------------------------------------------------------------
function DCRC_UpdateProfileList(topIndex)
	for ind=1, 10 do
		--Clears all 10 list elements.
		getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..ind.."_Text"):SetText("")
		getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..ind).profile=""
		getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..ind):Hide()
	end
	i=1
	j=1
	for index, entry in pairs(DialogChat_Options) do
		if(i>=topIndex) and (i<topIndex+10)then
			--Displays the topIndex's element through to the topIndex+12'th element in the list
			dot=string.find(index, "%.")
			
			getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..j).stringName=string.sub(index, 1, dot-1).." of "..string.sub(index, dot+1)
			getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..j.."_Text"):SetText(getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..j).stringName)
			getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..j).profile=index
			getglobal("DCRC_OptionWindow_Profiles_Panel_Entry"..j):Show()
			j=j+1
		end
		i=i+1
	end

	if(i<=10)then
		--the entire list will be displayed on a single, un-scrolling list.
		DCRC_OptionWindow_Profiles_Panel_Scroller:SetMinMaxValues(1,1)
	else		
		--The list will require scrolling.
		DCRC_OptionWindow_Profiles_Panel_Scroller:SetMinMaxValues(1,i-10)
	end
end
function DCRC_DeleteProfile(profileName)
	DialogChat_Options[profileName]=nil
end
function DCRC_CopyProfile(profileName)
	DCR_TempProfile={}
	for index, entry in pairs(DialogChat_Options[profileName]) do
		DCR_TempProfile[index]=DialogChat_Options[profileName][index]
	end
end
function DCRC_PasteProfile(newName)
	for index, entry in pairs(DCR_TempProfile)do
		DialogChat_Options[newName][index]=DCR_TempProfile[index]
	end
	if(newName==DCRPlayerIndex)then 
		DEFAULT_CHAT_FRAME:AddMessage("Some changes may require logout before taking effect")
	end
end

