DCR_UsedFrames={}
local DCR_FramesAllUsed=0
local DCR_LastActive= {0,0,0,0,0,0,0,0,0,0,0,0}
local DCR_OrderCreated={}
local DCR_IMFrames={1,2,3,4,5,6,7,8,9,10,11,12}
local DCR_CurrentlyOpenEditBox=""
local DCR_UseWho=""
local DCR_ButtonsHooked = nil
BINDING_HEADER_DIALOGCHATWINDOW = "Dialog Chat Window";
BINDING_NAME_BINDING_DCR1 = "Reply";
BINDING_NAME_BINDING_DCR2 = "Minimize all";
BINDING_NAME_BINDING_DCR3 = "Maximize all";
BINDING_NAME_BINDING_DCR4 = "Close all";

function DCR_OnLoad()
	if not(DCR_ButtonsHooked) then
		ChatFrameEditBox.DCR_Insert = ChatFrameEditBox.Insert;
		ChatFrameEditBox.Insert = function(self,theText)
			if(DCR_CurrentlyOpenEditBox~="")then
				getglobal(DCR_CurrentlyOpenEditBox):Insert(theText);
			else
				ChatFrameEditBox:DCR_Insert(theText);
			end
		end
		ChatFrameEditBox.DCR_IsVisible = ChatFrameEditBox.IsVisible;
		ChatFrameEditBox.IsVisible = function(self)
			if(DCR_CurrentlyOpenEditBox~="")then
				return true;
			else
				return ChatFrameEditBox:DCR_IsVisible();
			end
		end
		ChatFrameEditBox.DCR_HighlightText = ChatFrameEditBox.HighlightText;
		ChatFrameEditBox.HighlightText = function(self, theStart, theEnd)
			if(DCR_CurrentlyOpenEditBox~="")then
				getglobal(DCR_CurrentlyOpenEditBox):HighlightText(theStart, theEnd);
			else
				ChatFrameEditBox:DCR_HighlightText(theStart, theEnd);
			end
		end
	end

		DCR_ButtonsHooked = true;

end


function DCR_IncomingMessage(Name, Text)
	local Headder;
	MsgDate= date("%H:%M")
	
	if(DCR_UsedFrames[Name]==nil)then
		if(DCR_FramesAllUsed==1) and (DCRC_GetOption("MAXwidgets")>=1)then
			DCR_DeAllocateFrameOldest()
			DCR_AllocateFrame(Name)
		elseif(DCR_FramesAllUsed==0)then
			DCR_AllocateFrame(Name)
		end
		if (DCRC_GetOption("UseDock")==0) then
			getglobal("Window"..DCR_UsedFrames[Name]).HideWindow = 0;
		end
	end
	if(DCR_UsedFrames[Name]==nil)then
		
	else
		if DCRC_GetOption("MessageHeadder_Inc") == "NAME" then
			Headder = "["..Name.."]";
		else
			Headder = DCRC_GetOption("MessageHeadder_Inc");
		end
		DCR_LastActive[DCR_UsedFrames[Name]]=time()
		getglobal("Window"..DCR_UsedFrames[Name]).SecondsSinceLastEvent=0
		if(DCRC_GetOption("TimeStamp")==1)then
			line="<"..MsgDate.."> "..Headder.." "..Text
		else
			line= Headder.." "..Text
		end
		getglobal("Window"..DCR_UsedFrames[Name].."_Main_Chat"):AddMessage(line, DCRC_ParseColor(DCRC_GetOption("InboundColor")))
		DCR_UpdateWhoField(Name)
		DCR_LastFrameToGetWhisper="Window"..DCR_UsedFrames[Name].."_EditBox"
		if(DCRC_GetOption("AlertSound")~="OFF")then
			PlaySoundFile("Interface\\AddOns\\DialogChat\\Sounds\\"..DCRC_GetOption("AlertSound")..".wav");
		end
		if(getglobal("Window"..DCR_UsedFrames[Name]).Minimized==1) and (DCRC_GetOption("UseDock")==0) then
			getglobal("Window"..DCR_UsedFrames[Name]).UnReadMessages=getglobal("Window"..DCR_UsedFrames[Name]).UnReadMessages+1
			getglobal("Window"..DCR_UsedFrames[Name].."_MoveIt_Alias"):SetText(getglobal("Window"..DCR_UsedFrames[Name].."_MoveIt_Alias").BaseName.."   ("..getglobal("Window"..DCR_UsedFrames[Name]).UnReadMessages..")")
			getglobal("Window"..DCR_UsedFrames[Name]).isPulsing=true
		end


	end
end
function DCR_OutgoingMessage(Name, Text)
	local Headder;
	MsgDate= date("%H:%M")
	if(DCR_UsedFrames[Name]==nil)then
		if(DCR_FramesAllUsed==1) and (DCRC_GetOption("MAXwidgets")>=1)then
			DCR_DeAllocateFrameOldest()
			DCR_AllocateFrame(Name)
			--Old frame used
		elseif(DCR_FramesAllUsed==0)then
			DCR_AllocateFrame(Name)
		end
		if (DCRC_GetOption("UseDock")==0) then
			getglobal("Window"..DCR_UsedFrames[Name]).HideWindow = 0;
		end
	end
	if(DCR_UsedFrames[Name]==nil)then
		
	else
		DCR_UpdateWhoField(Name)
		if DCRC_GetOption("MessageHeadder_Out") == "NAME" then
			Headder = "["..UnitName("player").."]";
		else
			Headder = DCRC_GetOption("MessageHeadder_Out");
		end
		DCR_LastActive[DCR_UsedFrames[Name]]=time()
		getglobal("Window"..DCR_UsedFrames[Name]).SecondsSinceLastEvent=0
		if(DCRC_GetOption("TimeStamp")==1)then
			line="<"..MsgDate.."> "..Headder.." "..Text
		else
			line= Headder.." "..Text
		end
		getglobal("Window"..DCR_UsedFrames[Name].."_Main_Chat"):AddMessage(line, DCRC_ParseColor(DCRC_GetOption("OutboundColor")))
		getglobal("Window"..DCR_UsedFrames[Name].."_EditBox"):AddHistoryLine(Text)
	end
end
function DCR_Enable()
	
end
function DCR_Disable()
	DCR_MassClose()
end

-- Functions for Opening, Closing, Minimizing and Automation of widgets
function DCR_AllocateFrame(Name)
	--This function finds a frame that is not currently in use, and allocates it to the name given.
	for i=1, 12 do
		--There is already a widget for the specified person
		if(getglobal("Window"..i).Name==Name)then return end
	end
	for i=1, table.getn(DCR_IMFrames) do
		--scans all widgets seeing if it can be used.
		if(DCR_IMFrames[i]==0)then
			--Frame is in use, find another.
		elseif(i>DCRC_GetOption("MAXwidgets"))then
			--Max number of frames are used, no frame is allocated
			DCR_FramesAllUsed=1
			return
		else
			--frame is not in use and can be chosen and configured.
			DCR_IMFrames[i]=0
			DCR_UsedFrames[Name]=i
		getglobal("Window"..i).CombatHidden=1
			getglobal("Window"..i):Show();
			DCR_LastActive[DCR_UsedFrames[Name]]=time()
			if(i>=DCRC_GetOption("MAXwidgets"))then
				--Max number of frames are used
				DCR_FramesAllUsed=1
			end
			getglobal("Window"..DCR_UsedFrames[Name]).Name=Name
			DCR_OrderCreated[table.getn(DCR_OrderCreated)+1]=DCR_UsedFrames[Name]
			--returns when the frame is allocated.
			DCR_SetupWindow(Name)
			return
		end
	end
	--If all frames are NOT in use, this code will not execute.
	DCR_FramesAllUsed=1
end
function DCR_DeAllocateFrameByName(Name)
	if not(DCR_UsedFrames[Name]==nil)then
		if getglobal("Window"..DCR_UsedFrames[Name]).Minimized == 1 then
			DCR_RePositionWindow("Window"..DCR_UsedFrames[Name],0)
		end
		DCR_IMFrames[DCR_UsedFrames[Name]]=DCR_UsedFrames[Name]
		DCR_LastActive[DCR_UsedFrames[Name]]=0
			getglobal("Window"..DCR_UsedFrames[Name]):Hide()
			getglobal("Window"..DCR_UsedFrames[Name].."_MoveIt_Alias"):SetText("Null")
			getglobal("Window"..DCR_UsedFrames[Name]).Name="Null"
			DCR_FramesAllUsed=0
		for index, entry in pairs(DCR_OrderCreated)do
			if(DCR_OrderCreated[index]==DCR_UsedFrames[Name])then
				table.remove(DCR_OrderCreated,index)
			end
		end
		
		DCR_UsedFrames[Name]=nil
	end
end
function DCR_TimeoutFrame(Name)
	if Name ~= "Null" then
		DCR_DeAllocateFrameByName(Name)
	end
end
function DCR_DeAllocateFrameOldest()
	--finds and deallocates the oldest frame.
	Oldest={}
	Oldest[0]=0
	Oldest[1]=0
	for i=1, table.getn(DCR_IMFrames) do
		if(DCR_LastActive[i]>=Oldest[1])then
			Oldest[0]=i
			Oldest[1]=DCR_LastActive[i]
		end
	end
	-- At this point, Oldest should hold respectivly, the Oldest Frame Number, and the Time Code for that Frame
	if not(Oldest[0]==0)then
		DCR_DeAllocateFrameByName(getglobal("Window"..Oldest[0]).Name)
	end
end
function DCR_CloseButtonClicked(ParentName)
	--Deallocates the closed frame.
		DCR_DeAllocateFrameByName(getglobal(ParentName).Name);
end
function DCR_ToggleMinimizeWindow(frame, toState)
	-- Animation1:Max>Min h
	-- Animation2:Max>Min w
	-- Animation3:Min>Max w
	-- Animation4:Min>Max h
	-- Animation5:Max
	-- Animation6:Min
	-- Animation0:Idle
	Frm=getglobal(frame)
	Frm.Bottom = Frm:GetBottom()
	Frm.Left = Frm:GetLeft()
		thisState=Frm.Minimized
		if(toState==nil)then
			toState=abs(thisState-1)
		end
		if(thisState==toState)then
			return
		end
		if(thisState==0)then
			Frm.Minimized=1
			DCRC_SetOption(frame.."_minimized", 1)
			Frm.Animation = 1;
			Frm.Animationframe_h = 0;
			Frm.Animationframe_w = 0;
		elseif(thisState==1)then
			Frm.UnReadMessages=0
			getglobal(Frm:GetName().."_MoveIt_Alias"):SetText(getglobal(Frm:GetName().."_MoveIt_Alias").BaseName)
			Frm.Minimized=0
			DCRC_SetOption(frame.."_minimized", 0)
			Frm.Animation = 3;
			Frm.Animationframe_h = 0;
			Frm.Animationframe_w = 0;
			getglobal(frame.."_MoveIt_Alias"):SetTextColor(DCRC_ParseColor(DCRC_GetOption("NameColor")))
			Frm.isPulsing=false
			Frm.SecondsSinceLastEvent=0
		end
end
function DCR_RePositionWindow(FrameName,toState)
	local Frame = getglobal(FrameName);
	local Bottom = Frame.Bottom;
	local Left = Frame.Left;
	local h = DCRC_GetOption("COREdimensionY")
	local w = DCRC_GetOption("COREdimensionX")
	local MinWidth = 200;
	if (DCRC_GetOption("UseDock")==1) then
		MinWidth = 0;
	end

-- Max>Min
	if toState == 1 and Frame.Minimized == 0 then
		Frame.Minimized=1
		DCRC_SetOption(FrameName.."_minimized", 1)
		Frame:SetHeight(30);
		if (DCRC_GetOption("UseDock")==1) then
			Frame:SetWidth(8);
			getglobal(FrameName.."_MoveIt"):SetWidth(8);
			Frame:Hide();
		else
			Frame:SetWidth(200);
			getglobal(FrameName.."_MoveIt"):SetWidth(200);
		end
		Frame:ClearAllPoints();
		if(DCRC_GetOption("MinimizeUp")==1)then
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
--				Frame:SetPoint("BOTTOMLEFT",Left + (DCRC_GetOption("COREdimensionX") - Frame:GetWidth()), Bottom)
				Frame:SetPoint("BOTTOMLEFT",Left+w-8, Bottom)
			else
				Frame:SetPoint("BOTTOMLEFT",Left, Bottom)
			end
		else
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
				Frame:SetPoint("BOTTOMLEFT",Left + (DCRC_GetOption("COREdimensionX") - Frame:GetWidth()), Bottom + DCRC_GetOption("COREdimensionY") - 30)
			else
				Frame:SetPoint("BOTTOMLEFT",Left, Bottom +h-30)
			end
		end
--		Frame.Bottom = Frame:GetBottom();
--		Frame.Left = Frame:GetLeft();
		getglobal(FrameName.."_Main_Chat"):Hide()
		getglobal(FrameName.."_EditBox"):Hide()
		getglobal(FrameName.."_Main_WhoField"):Hide()
		getglobal(FrameName.."_BottomButton"):Hide()
		getglobal(FrameName.."_DownButton"):Hide()
		getglobal(FrameName.."_UpButton"):Hide()
		getglobal(FrameName.."_Main"):Hide()
		if (DCRC_GetOption("UseDock")==0) then
			getglobal(FrameName.."_MoveIt_CloseButton"):Show()
			getglobal(FrameName.."_MoveIt_MinimizeButton"):Hide()
			getglobal(FrameName.."_MoveIt_MaxmizeButton"):Show()
		else
			getglobal(FrameName.."_MoveIt_CloseButton"):Hide()
			getglobal(FrameName.."_MoveIt_MinimizeButton"):Hide()
			getglobal(FrameName.."_MoveIt_MaxmizeButton"):Hide()
		end
-- Min>Max
	elseif toState == 0 and Frame.Minimized == 1 then
		Frame.UnReadMessages=0
		Frame.Minimized=0
		DCRC_SetOption(FrameName.."_minimized", 1)
		getglobal(FrameName.."_MoveIt_Alias"):SetTextColor(DCRC_ParseColor(DCRC_GetOption("NameColor")))
		Frame.isPulsing=false
		Frame.SecondsSinceLastEvent=0
		Frame:SetWidth(w);
		getglobal(FrameName.."_MoveIt"):SetWidth(w);
		Frame:SetHeight(h);
		Frame:ClearAllPoints();
		if(DCRC_GetOption("MinimizeUp")==1)then
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
--				Frame:SetPoint("BOTTOMLEFT",Left+MinWidth-w+8, Bottom)
				Frame:SetPoint("BOTTOMLEFT",Left, Bottom)
			else
				Frame:SetPoint("BOTTOMLEFT",Left, Bottom)
			end
		else
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
--				Frame:SetPoint("BOTTOMLEFT",Left-w+8, Bottom+30-h)
				Frame:SetPoint("BOTTOMLEFT",Left, Bottom)
			else
				Frame:SetPoint("BOTTOMLEFT",Left, Bottom)
			end
		end
		Frame.Bottom = Frame:GetBottom();
		Frame.Left = Frame:GetLeft();
		getglobal(FrameName.."_Main"):Show()
		getglobal(FrameName.."_Main_Chat"):Show()
		getglobal(FrameName.."_Main_WhoField"):Show()
		getglobal(FrameName.."_MoveIt_CloseButton"):Show()
		getglobal(FrameName.."_MoveIt_MinimizeButton"):Show()
		getglobal(FrameName.."_MoveIt_MaxmizeButton"):Hide()
		if(DCRC_GetOption("ScrollButtons")==0)then
			getglobal(FrameName.."_BottomButton"):Hide()
			getglobal(FrameName.."_DownButton"):Hide()
			getglobal(FrameName.."_UpButton"):Hide()
		elseif(DCRC_GetOption("ScrollButtons")==1)then
			getglobal(FrameName.."_BottomButton"):Show()
			getglobal(FrameName.."_DownButton"):Show()
			getglobal(FrameName.."_UpButton"):Show()
		end
	end
end

function DCR_MassMinimize()
	for i=1, 12 do
		DCR_ToggleMinimizeWindow("Window"..i, 1)
	end
end
function DCR_MassMaximize()
	for i=1, 12 do
		DCR_ToggleMinimizeWindow("Window"..i, 0)
	end
end
function DCR_MassClose()
	for i=1, 12 do
		DCR_DeAllocateFrameOldest()
	end
end
function DCR_EnterCombat()
	if(DCRC_GetOption("CombatMinimize")==1)then
		--Minimize all un-minimized windows.
		for i=1, 12 do
			if(getglobal("Window"..i).Minimized==0) and (DCR_IMFrames[i]==0) then
				getglobal("Window"..i).CombatMinimized=1;
				DCR_ToggleMinimizeWindow("Window"..i,1);
			end
		end
	elseif(DCRC_GetOption("CombatHide")==1)then
		--Hide all visible windows.
		for i=1, 12 do
			if(getglobal("Window"..i):IsVisible()) and (DCR_IMFrames[i]==0) then
				getglobal("Window"..i).CombatHidden=1
				getglobal("Window"..i,1):Hide()
			end
		end
	end
end
function DCR_ExitCombat()
	if(DCRC_GetOption("CombatMinimize")==1)then
		--Maximize all auto-minimized windows.
		for i=1, 12 do
			if(getglobal("Window"..i).CombatMinimized==1)then
				getglobal("Window"..i).CombatMinimized=0
				DCR_ToggleMinimizeWindow("Window"..i,0)
			end
		end
	elseif(DCRC_GetOption("CombatHide")==1)then
		--Show all auto-hidden windows.
		for i=1, 12 do
			if(getglobal("Window"..i).CombatHidden==1) then
				getglobal("Window"..i).CombatHidden=0
				getglobal("Window"..i,1):Show()
			end
		end
	end
end



-- Functions for keeping Widget Appearances up to date
function DCR_PulseWidget(elapsed)
	this.TimeSinceLastUpdate = this.TimeSinceLastUpdate + elapsed; 
	timeDelta=0.2
	if (this.TimeSinceLastUpdate > timeDelta) then
		if(this.isPulsing==false)then return end
	    step = this.PulseStep
		-- Steps 1-10 from Name To Pulse
		-- Steps 11-20 Pulse to Name
		-- Steps 21-50 Name
		nameR, nameG, nameB = DCRC_ParseColor(DCRC_GetOption("NameColor"))
		pulseR, pulseG, pulseB = DCRC_ParseColor(DCRC_GetOption("PulseColor"))
		dR = (pulseR-nameR)*.1
		dG = (pulseG-nameG)*.1
		dB = (pulseB-nameB)*.1
		
		if(step==50)then this.PulseStep=1 else this.PulseStep=step+1 end
		
		if(step>=21)then
			if(step==21)then getglobal(this:GetName().."_MoveIt_Alias"):SetTextColor(DCRC_ParseColor(DCRC_GetOption("NameColor"))) end
		elseif(step>=1)and(step<=10)then
			--From Name to Pulse
			getglobal(this:GetName().."_MoveIt_Alias"):SetTextColor(nameR+dR*step,nameG+dG*step,nameB+dB*step)
		elseif(step>=11)and(step<=20)then
			aStep=step-10
			--From Pulse to Name
			getglobal(this:GetName().."_MoveIt_Alias"):SetTextColor(pulseR-dR*aStep,pulseG-dG*aStep,pulseB-dB*aStep)
		end
		this.TimeSinceLastUpdate = 0;
	end
	
end
function DCR_Animation(elapsed)
	local h = DCRC_GetOption("COREdimensionY");
	local w = DCRC_GetOption("COREdimensionX");
	local FrameName = this:GetName();
	local MinWidth = 200;
	if (DCRC_GetOption("UseDock")==1) then
		MinWidth = 0;
	end
	local Bottom=this.Bottom
	local Left=this.Left
	-- Animation1:Max>Min h
	-- Animation2:Max>Min w
	-- Animation3:Min>Max w
	-- Animation4:Min>Max h
	-- Animation5:Max
	-- Animation6:Min
	-- Animation0:Idle

	if this.Animation ~= 0 then
		this.Animationframe_h = this.Animationframe_h + elapsed;
		this.Animationframe_w = this.Animationframe_w + elapsed;
	end

-- Minimize Animation
	if this.Animation == 1 or this.Animation == 2 then
		getglobal(FrameName.."_Main_Chat"):Hide()
		getglobal(FrameName.."_EditBox"):Hide()
		getglobal(FrameName.."_Main_WhoField"):Hide()
		getglobal(FrameName.."_MoveIt_CloseButton"):Hide()
		getglobal(FrameName.."_MoveIt_MinimizeButton"):Hide()
		getglobal(FrameName.."_MoveIt_MaxmizeButton"):Hide()
		getglobal(FrameName.."_BottomButton"):Hide()
		getglobal(FrameName.."_DownButton"):Hide()
		getglobal(FrameName.."_UpButton"):Hide()
	end
	if this.Animation == 1 then
		this:SetHeight(h-((h-30)/0.5*this.Animationframe_h));
		if h-((h-30)/0.5*this.Animationframe_h) <= 38 then
			getglobal(FrameName.."_Main"):Hide()
		end
		if h-((h-30)/0.5*this.Animationframe_h) <= 30 then
			this.Animationframe_w = 0;
			this:SetHeight(30);
			this.Animation = 2;
		end
			this:ClearAllPoints()
			if(DCRC_GetOption("MinimizeUp")==1)then
				this:SetPoint("BOTTOMLEFT",Left, Bottom)
			else
				this:SetPoint("BOTTOMLEFT",Left, Bottom+h-this:GetHeight())
			end
	end
	if this.Animation == 2 then
		this:ClearAllPoints()
		this:SetWidth(w-((w-MinWidth)/0.5*this.Animationframe_w));
		getglobal(FrameName.."_MoveIt"):SetWidth(w-((w-MinWidth)/0.5*this.Animationframe_w));
		if MinWidth ~=0 then
			if w -((w-MinWidth)/0.5*this.Animationframe_w) <= MinWidth then
				this.Animationframe_h = 0;
				this:SetWidth(MinWidth);
				getglobal(FrameName.."_MoveIt"):SetWidth(MinWidth);
				this.Animation = 6;
			end
		else
			if w -((w-MinWidth)/0.5*this.Animationframe_w) <= 8 then
				this.Animationframe_h = 0;
				this:SetWidth(8);
				this:Hide();
				this.Animation = 6;
			end
		end
		if(DCRC_GetOption("MinimizeUp")==1)then
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
				this:SetPoint("BOTTOMLEFT",Left+(w-this:GetWidth()), Bottom)
			else
				this:SetPoint("BOTTOMLEFT",Left, Bottom)
			end
		else
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
				this:SetPoint("BOTTOMLEFT",Left+(w-this:GetWidth()), Bottom+h-this:GetHeight())
			else
				this:SetPoint("BOTTOMLEFT",Left, Bottom+h-this:GetHeight())
			end
		end
	end

-- Maxmize Animation
	if this.Animation == 3 then
		this:SetWidth(MinWidth + ((w - MinWidth) / 0.5) * this.Animationframe_w+8);
		if this.HideWindow ~=1 then
			this:Show()
		end
		getglobal(FrameName.."_MoveIt"):SetWidth(MinWidth + ((w - MinWidth) / 0.5) * this.Animationframe_w+8);
		if MinWidth + ((w - MinWidth) / 0.5) * this.Animationframe_w+8 >= w then
			this.Animationframe_h = 0;
			this:SetWidth(w);
			getglobal(FrameName.."_MoveIt"):SetWidth(w);
			this.Animation = 4;
		end
		this:ClearAllPoints()
		if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
			this:SetPoint("BOTTOMLEFT",Left+MinWidth-this:GetWidth(), Bottom)
		else
			this:SetPoint("BOTTOMLEFT",Left, Bottom)
		end
	elseif this.Animation == 4 then
		this:SetHeight(30 + ((h / 0.5) * this.Animationframe_h));
		if ((h / 0.5) * this.Animationframe_h) >= 8 then
			getglobal(FrameName.."_Main"):Show()
		end
		if 30 + ((h / 0.5) * this.Animationframe_h) >= h then
			this.Animationframe_w = 0;
			this:SetHeight(h);
			this.Animation = 5;
		end
		this:ClearAllPoints()
		if(DCRC_GetOption("MinimizeUp")==1)then
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
				this:SetPoint("BOTTOMLEFT",Left+MinWidth-w+8, Bottom)
			else
				this:SetPoint("BOTTOMLEFT",Left, Bottom)
			end
		else
			if (DCRC_GetOption("UseDock")==1) and (DCRC_GetOption("DockPosition_Right")==1) then
				this:SetPoint("BOTTOMLEFT",Left+MinWidth-w+8, Bottom+30-this:GetHeight())
			else
				this:SetPoint("BOTTOMLEFT",Left, Bottom+30-this:GetHeight())
			end
		end
	end

	if this.Animation == 5 then
		getglobal(FrameName.."_Main"):Show()
		getglobal(FrameName.."_Main_Chat"):Show()
		getglobal(FrameName.."_Main_WhoField"):Show()
		getglobal(FrameName.."_MoveIt_CloseButton"):Show()
		getglobal(FrameName.."_MoveIt_MinimizeButton"):Show()
		getglobal(FrameName.."_MoveIt_MaxmizeButton"):Hide()
		if(DCRC_GetOption("ScrollButtons")==0)then
			getglobal(FrameName.."_BottomButton"):Hide()
			getglobal(FrameName.."_DownButton"):Hide()
			getglobal(FrameName.."_UpButton"):Hide()
		elseif(DCRC_GetOption("ScrollButtons")==1)then
			getglobal(FrameName.."_BottomButton"):Show()
			getglobal(FrameName.."_DownButton"):Show()
			getglobal(FrameName.."_UpButton"):Show()
		end
		this.Animation = 0
	elseif this.Animation == 6 then
		getglobal(FrameName.."_Main"):Hide()
		getglobal(FrameName.."_Main_Chat"):Hide()
		getglobal(FrameName.."_EditBox"):Hide()
		getglobal(FrameName.."_Main_WhoField"):Hide()
		if (DCRC_GetOption("UseDock")==0) then
			getglobal(FrameName.."_MoveIt_CloseButton"):Show()
			getglobal(FrameName.."_MoveIt_MinimizeButton"):Hide()
			getglobal(FrameName.."_MoveIt_MaxmizeButton"):Show()

		else
			getglobal(FrameName.."_MoveIt_CloseButton"):Hide()
			getglobal(FrameName.."_MoveIt_MinimizeButton"):Hide()
			getglobal(FrameName.."_MoveIt_MaxmizeButton"):Hide()
		end
		getglobal(FrameName.."_BottomButton"):Hide()
		getglobal(FrameName.."_DownButton"):Hide()
		getglobal(FrameName.."_UpButton"):Hide()
		this.Animation = 0
	end
end
function DCR_SetupWindow(Name)
	local FrameName = "Window"..DCR_UsedFrames[Name];
	--Sets up the frame associated to 'Name', as per the saved variables.
	getglobal(FrameName).Name=Name
	
	if(not(DialogChat_Aliases[GetRealmName()][Name]==nil))then
		--Show Alias, Hide Name
		getglobal(FrameName.."_MoveIt_Alias"):SetText(DialogChat_Aliases[GetRealmName()][Name])
		getglobal(FrameName.."_MoveIt_Alias").BaseName=DialogChat_Aliases[GetRealmName()][Name]
	else
		-- Hide Alias, Show Name
		getglobal(FrameName.."_MoveIt_Alias"):SetText(Name)
		getglobal(FrameName.."_MoveIt_Alias").BaseName=Name
	end
	getglobal(FrameName.."_MoveIt_Alias"):SetTextColor(DCRC_ParseColor(DCRC_GetOption("NameColor")))
	getglobal(FrameName).UnReadMessages=0
--	DCRC_DropDown_OnLoad(getglobal(FrameName.."_MoveIt_DropDown"));
	--Resets the chat log
	Frame=getglobal(FrameName.."_Main_Chat")
	Frame:Clear()
	Frame:ScrollToBottom()
	Path,_,Flags=Frame:GetFont()
	Frame:SetFont(Path,DCRC_GetOption("FontSize"),Flags)
	Frame:Show()
		
	getglobal(FrameName.."_EditBox"):Hide()
	getglobal(FrameName.."_EditBox"):SetText("")
	
	--Set /Who Data
	getglobal(FrameName.."_Main_WhoField"):SetTextColor(DCRC_ParseColor(DCRC_GetOption("DetailColor")))
	DCR_UpdateWhoField(Name)
		--This line is included in case the widget is auto-closed due to the level threshold
		if(DCR_UsedFrames[Name]==nil)then 
			if(DCR_UsedFrames==nil)then DCR_UsedFrames={} end
			return
		end
	
	--Set Size
	getglobal(FrameName):SetAlpha(DCRC_GetOption("Transparency"))
	getglobal(FrameName.."_MoveIt"):SetAlpha(1)
	getglobal(FrameName.."_Main_Chat"):SetAlpha(1)
	getglobal(FrameName.."_Main_Chat"):SetFading(nil)
	getglobal(FrameName.."_MoveIt_CloseButton"):SetAlpha(1)
	getglobal(FrameName.."_MoveIt_MinimizeButton"):SetAlpha(1)
	getglobal(FrameName.."_MoveIt_MaxmizeButton"):SetAlpha(1)
	getglobal(FrameName.."_MoveIt_MinimizeButton"):Show()
	getglobal(FrameName.."_MoveIt_MaxmizeButton"):Hide()
	getglobal(FrameName.."_MoveIt_CloseButton"):SetFrameLevel(getglobal(FrameName.."_MoveIt"):GetFrameLevel()+1)
	getglobal(FrameName.."_MoveIt_MinimizeButton"):SetFrameLevel(getglobal(FrameName.."_MoveIt"):GetFrameLevel()+1)
	getglobal(FrameName.."_MoveIt_MaxmizeButton"):SetFrameLevel(getglobal(FrameName.."_MoveIt"):GetFrameLevel()+1)

	getglobal(FrameName.."_EditBox"):SetAlpha(1)
	if(DCRC_GetOption("ScrollButtons")==0)then
		getglobal(FrameName.."_BottomButton"):Hide()
		getglobal(FrameName.."_DownButton"):Hide()
		getglobal(FrameName.."_UpButton"):Hide()
	elseif(DCRC_GetOption("ScrollButtons")==1)then
		getglobal(FrameName.."_BottomButton"):Show()
		getglobal(FrameName.."_DownButton"):Show()
		getglobal(FrameName.."_UpButton"):Show()
	end
	getglobal(FrameName).Animation = 0;

	local Window_Minimized = DCRC_GetOption(FrameName.."_minimized");
	if Window_Minimized == 1 then
		DCR_RePositionWindow(FrameName,0)
	end
	getglobal(FrameName).Minimized=0
	DCR_ResizeWidget(DCR_UsedFrames[Name])
	if (DCRC_GetOption("UseDock")==1) then
		getglobal(FrameName).Bottom = getglobal("Window1"):GetBottom();
		getglobal(FrameName).Left = getglobal("Window1"):GetLeft();
	else
		getglobal(FrameName).Bottom = getglobal(FrameName):GetBottom();
		getglobal(FrameName).Left = getglobal(FrameName):GetLeft();
	end
	DCR_RePositionWindow(FrameName,1)
	getglobal(FrameName).HideWindow = 1;
	if(DCRC_GetOption("LoadMinimized")==0) then
		DCR_ToggleMinimizeWindow(FrameName, 0)
	end

	--Set history
	DCRL_PutHistoryToWidgetChat(FrameName.."_Main_Chat",Name)
end
function DCR_ResizeWidget(which)
	local h = DCRC_GetOption("COREdimensionY")
	local w = DCRC_GetOption("COREdimensionX")
	if(which==0)or(which==nil)then
		--resize all widgets
		for i=1, 12 do
			DCR_ResizeWidget(i)
		end
	else
		if(getglobal("Window"..which).Minimized~=1) then
			getglobal("Window"..which):SetHeight(h)
			getglobal("Window"..which):SetWidth(w)	
			getglobal("Window"..which.."_MoveIt"):SetWidth(w)
			getglobal("Window"..which.."_Main_Chat"):SetWidth(w-20)
			getglobal("Window"..which.."_Main_Chat"):SetHeight(h-55)
		end
		DCR_SetWidgetScale(which)
	end
end
function DCR_SetTransparent()
	--Sets the transparency of all widgets
	for i=1, 12 do
		getglobal("Window"..i):SetAlpha(DCRC_GetOption("Transparency"))
		getglobal("Window"..i.."_MoveIt"):SetAlpha(1)
		getglobal("Window"..i.."_Main_Chat"):SetAlpha(1)
		getglobal("Window"..i.."_MoveIt_CloseButton"):SetAlpha(1)
		getglobal("Window"..i.."_MoveIt_MinimizeButton"):SetAlpha(1)
		getglobal("Window"..i.."_EditBox"):SetAlpha(1)
	end
end
function DCR_SetFontSize()
	--Sets the text size on all the widgets.
	for i=1, 12 do
		Frame=getglobal("Window"..i.."_Main_Chat")
		Path,_,Flags=Frame:GetFont()
		Frame:SetFont(Path,DCRC_GetOption("FontSize"),Flags)
	end
end
function DCR_SetWidgetScale(i)
	if(true)then return end
	getglobal("Window"..i):SetScale(DCRC_GetOption("WidgetScale"))
end
function DCR_ResetWidgetPositions()
	--this function was inculded to fix an issue where widgets would move off the edge of the screen
	--and become un-movable.  After execution, all widgets will be vertically aligned near the center
	--of the screen de-allocated
	Resetting=1
	for i=1, 12 do
		DCR_DeAllocateFrameOldest()
	end
	DCR_AllocateFrame("A")
	DCR_AllocateFrame("B")
	DCR_AllocateFrame("C")
	DCR_AllocateFrame("D")
	DCR_AllocateFrame("E")
	DCR_AllocateFrame("F")
	DCR_AllocateFrame("G")
	DCR_AllocateFrame("H")
	DCR_AllocateFrame("I")
	DCR_AllocateFrame("J")
	DCR_AllocateFrame("K")
	DCR_AllocateFrame("L")
	FCVal=(GetScreenHeight()/2)-90
	for i=1, 12 do
		DCR_ToggleMinimizeWindow("Window"..i, 1)
		getglobal("Window"..i):ClearAllPoints()
		getglobal("Window"..i):SetPoint("TOP" ,0 , (-1)*FCVal)
		FCVal=FCVal+30
	end
	for i=1, 12 do
		DCR_DeAllocateFrameOldest()
	end
	Resetting=0
end

function DCR_UpdateWhoField(Name)
	if(DCRC_GetOption("IgnoreWhos")==1)then getglobal("Window"..DCR_UsedFrames[Name].."_Main_WhoField"):SetText("") return end
	found=0
	charname, guildname, level, race, class, zone, partied = ""
		--Checks if they are in the same BG as you... Otherwise continues with standard /who retrieval.
		if(string.find(Name, "-")~=nil)then
			--Char is inside a BG
			for i=1, GetNumBattlefieldScores() do
				name, _, _, _, _, _, _, race, class, _, _ = GetBattlefieldScore(i)
				if(name==Name)then
					getglobal("Window"..DCR_UsedFrames[Name].."_Main_WhoField"):SetText("BG Member: "..name.." "..race.." "..class)
					return
				end
			end
		end
	
	
		--Scans the currently open who results before performing it's own /who
--		for i=1, GetNumWhoResults() do	
--			charname, guildname, level, race, class, zone, partied = GetWhoInfo(i);
--			if(charname==Name)then
--				found=1
--				break
--			end
--		end

		if not(zone) then
			zone = "Unknown Zone";
		end

		if(found==1)then
			--a match was found, and it will be used.
			DCR_UseWho=""
			if(guildname=="")then
				getglobal("Window"..DCR_UsedFrames[Name].."_Main_WhoField"):SetText(level.." "..class.." at "..zone)
			else
				getglobal("Window"..DCR_UsedFrames[Name].."_Main_WhoField"):SetText("<"..guildname.."> "..level.." "..class.." at "..zone)
			end
			if(level<=DCRC_GetOption("LevelThreshold") and (DCRC_IsGuildieOrFriend(Name)==false))then
				DCR_DeAllocateFrameByName(Name)
				local find = 0;
				for i=1,12 do
					local BaseName = getglobal("Window"..i).Name;
					if BaseName ~= nil and BaseName ~= "Null" then
						find = 1;
						break
					end
				end
				if find == 0 then
					getglobal("DCR_DockList"):Hide();
				end
				DCRD_UpdateDock();
				DEFAULT_CHAT_FRAME:AddMessage("|cff0000FFDialogChat:|r Message ignored from "..Name..", player is below level "..DCRC_GetOption("LevelThreshold"), 100, 100, 100, 1.0, UIERRORS_HOLD_TIME)
			end
		else
			--No match is found, must perform my own /who
			SetWhoToUI(1)
			DCR_UseWho=Name
			SendWho(Name);
			-- this Method will 'continue' in DCR_WhoActivated() when the /who command has been completed
		end
if getglobal("FriendsFrame"):IsShown() then
	ToggleFriendsFrame(2);
end
end
function DCR_WhoActivated()
	if(DCR_UseWho=="")then
		SetWhoToUI(0)
		return
	else
		SetWhoToUI(0)
		charname, guildname, level, race, class, zone, partied=""
		for i=1, GetNumWhoResults() do
			charname, guildname, level, race, class, zone, partied = GetWhoInfo(i);

			if not(zone) or zone == "" then
				zone = "Unknown Zone";
			end
			if(charname==DCR_UseWho)then
				break
			end
		end
		if(charname~=DCR_UseWho)then
			charname=""
			guildname="Information could not be found"
			level=""
			race=""
			class=""
			zone=""
			partied =""
		end
if getglobal("FriendsFrame"):IsShown() then
	ToggleFriendsFrame(2);
end
		if(DCR_UseWho==nil)then DCR_UseWho="" return end
		if(guildname=="")then
			getglobal("Window"..DCR_UsedFrames[DCR_UseWho].."_Main_WhoField"):SetText(level.." "..class.." at ")
		else
			getglobal("Window"..DCR_UsedFrames[DCR_UseWho].."_Main_WhoField"):SetText("<"..guildname.."> "..level.." "..class.." at "..zone)
		end
		if level =="" then level=1; end
		if(level<=DCRC_GetOption("LevelThreshold")) and not(DCRC_IsGuildieOrFriend(DCR_UseWho)) then
			DCR_DeAllocateFrameByName(DCR_UseWho)
			local find = 0;
			for i=1,12 do
				local BaseName = getglobal("Window"..i).Name;
				if BaseName ~= nil and BaseName ~= "Null" then
					find = 1;
					break
				end
			end
			if find == 0 then
				getglobal("DCR_DockList"):Hide();
			end
			DCRD_UpdateDock();
			DEFAULT_CHAT_FRAME:AddMessage("|cff0000FFDialogChat:|r Message ignored from "..DCR_UseWho..", player is below level "..DCRC_GetOption("LevelThreshold"), 100, 100, 100, 1.0, UIERRORS_HOLD_TIME)
		end
		DCR_UseWho=""
	end
end



-- Frame specific or General UI required functions
function DCR_EnterPressed(frame)
	--sends the message contained within the edit box.
	text=getglobal(frame.."_EditBox"):GetText()
	Name=getglobal(frame).Name
	if(string.sub(text,1,1)=='/')then
		--If the text starts with a slash, then it treats it as a slash command, 
		--which is forwarded to the chatframe1
		ChatFrame1.editBox:SetText(text)
		ChatEdit_SendText(ChatFrame1.editBox, 1)
	else
		SendChatMessage(text, "WHISPER", DCR_Language, Name);
	end
	if(IsShiftKeyDown())then
		getglobal(frame.."_EditBox"):SetText("")
	else
		DCR_HideEditBox(frame)
	end
end
function DCR_EscapePressed(frame)
	DCR_HideEditBox(frame)
end
function DCR_HideEditBox(frame)
	getglobal(frame.."_EditBox"):Hide()
	getglobal(frame.."_EditBox"):SetText("")
end
function DCR_ShowEditBox(frame, source)
	if(source=="CLICK") and (DCRC_GetOption("EditOnClick")==1)then
		if(not getglobal(frame.."_EditBox"):IsVisible())then
			getglobal(frame.."_EditBox"):Show()
			getglobal(frame.."_EditBox"):SetFocus()
			getglobal("ChatFrameEditBox"):Hide()
		elseif(getglobal(frame.."_EditBox"):IsVisible()) and (getglobal(frame.."_EditBox"):GetText()=="")then
			DCR_HideEditBox(frame)
		end
	elseif(source=="ENTER") and (DCRC_GetOption("EditOnClick")==0)then
		getglobal(frame.."_EditBox"):Show()
		getglobal(frame.."_EditBox"):SetFocus()
		getglobal("ChatFrameEditBox"):Hide()
	end
end

--Hooked functions for linking items
function DCR_SetLastOpenBox(box)
	DCR_CurrentlyOpenEditBox=box
end